' Attiny-Platine von E. Eube, G. Heinrichs und U. Ihlefeldt
' plus I2C-Temperatursensor LM75 plus STI1000
' LEDs an PortB.0 (rot), PortB.1 (gelb)
' 10 Temperaturen werden ber STI100 auf USB-Stick geschrieben
' STI100 ber TTL-COM/USART (vertrgt 5 V)
' Speichern der Daten im ASCII-Format durch Leerzeichen getrennt
'
' Achtung: Beim Laden des Programms den STI100
' vom Attiny trennen (Rxd und Txd oder 5V-Leitung);
' danach Attiny-Platine ausschalten; jetzt Verbindung wiederherstellen;
' dann Platine wieder einschalten!
'----------------------------------------------------------------------------

$regfile = "attiny2313.dat"                                 'Attiny2313
$crystal = 4000000                                          '4 MHz
$baud = 9600

'**********************************************************
'******************* Deklarationen ************************

Dim Temperatur As Byte
Dim Adresse As Byte
Dim Dateiname As String * 20
Dim Antwort As String * 20
Dim I As Byte
Const Prompt = ">"                                          'Der vollstndige Prompt D:\> ist wegen des \-Zeichens problematisch
Const Cr = 13                                               'CR-Steuerzeichen
Declare Sub Messung
Declare Sub Usb_init
Declare Sub Wert_speichern
Declare Sub Schluss

'****************** Initialisierung ***********************

Ddrb = &B11111111                                           'Port B als Ausgangsport
Ddrd = &B01110000                                           'D4, D5, D6 als Ausgang; Rest als Eingang
Portd = &B10001111                                          'Eingnge auf high legen

Config Scl = Portb.7                                        'Konfigurieren von I2C
Config Sda = Portb.5

Adresse = 153                                               'Adresse des LM75 (kann auch anders sein!)
Dateiname = "tempera5.txt"                                  'keine berlangen Dateinamen

'**********************************************************
'******************** Hauptprogramm ***********************

Call Usb_init
If Antwort = Prompt Then
  Portb.0 = 1                                               'rote LED an: jetzt usb-Stick nicht entfernen
  For I = 1 To 10
    Portb.1 = 1                                             'gelbe Led blinkt whrend Messung
    Call Messung
    Call Wert_speichern
    Portb.1 = 0
    Wait 2
  Next I
  Call Schluss
  Portb.0 = 0                                               'rote LED aus; USB-Stick kann entfernt werden
End If
End

'**********************************************************
'******************* Unterprogramme ***********************

Sub Messung
  I2cstart
  I2cwbyte Adresse
  I2crbyte Temperatur , Nack                                'Kein Acknowledge
  I2cstop
  Waitms 300
End Sub

Sub Usb_init
  Do
    Input Antwort Noecho
    Antwort = Right(antwort , 1)                            'wegen Problemen mit \ nur auf > testen
  Loop Until Antwort = Prompt                               'vierte Antwort sollte Prompt sein

  Portb.2 = 1                                               'USB-Stick eingeloggt
  Waitms 100
  Portb.2 = 0
  Wait 1

  Printbin Cr                                               'Puffer bei sti100 leeren; denn: ggf. sendet Attiny am Anfang ein sinnloses Zeichen. Kann entfernt werden, wenn STI100 nach dem Attiny eingeschaltet wird.
  Input Antwort Noecho

  Print "OPW " ; Dateiname;                                 'semikolon verhindert CR LF
  Printbin Cr                                               'CarriageReturn ohne LineFeed
  Input Antwort Noecho
  Antwort = Right(antwort , 1)
  If Antwort = Prompt Then                                  'Datei geffnet
    Portb.1 = 1
    Waitms 100
    Portb.1 = 0
  End If
End Sub

Sub Wert_speichern
  Print "WRF " ;
  Printbin 0
  Printbin 0
  Printbin 0
  Printbin 3                                                'Zwei Ziffern und 1 Leerzeichen-> 3 Bytes
  Printbin Cr
  Print Temperatur ; " ";
  Input Antwort Noecho
End Sub

Sub Schluss
  Print "CLF " ; Dateiname;
  Printbin Cr
  Input Antwort Noecho
End Sub


'**********************************************************
'******************Interruptroutinen***********************